///File : DialogInfoDevis.cpp
//------------------------------------------------------------------------------
/*
    This file is part of DevisMaker.

    DevisMaker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DevisMaker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DevisMaker.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "DialogInfoDevis.hpp"
//------------------------------------------------------------------------------

DialogInfoDevis::DialogInfoDevis( wxWindow* parent, wxWindowID id, ConfigManager *cfg, ConfigManager *defaultCfg, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : DialogProperty( parent, id, cfg, defaultCfg, title, pos, size, style )
{
    wxPanel *PagePanel;
    wxBoxSizer *PageSizer;

    // General
    PagePanel = new wxPanel(GetNotebook(), wxID_ANY);
    PageSizer = new wxBoxSizer(wxVERTICAL);
    AddParamCtrl(type_singleLine, PagePanel, PageSizer, "name", _("Name :"));
    AddParamCtrl(type_multiLine, PagePanel, PageSizer, "info", _("Information :"));
    // Ajout de la date...
    m_txtInfo = static_cast<wxTextCtrl*>(m_paramCtrls[m_paramCtrls.size() - 1].ctrl); // On prend le dernier ctrl
	wxButton *BtAddDate = new wxButton(PagePanel, wxID_ANY, _("Add date"));
	PageSizer->Add(BtAddDate, 0, wxALL, 5 );
	BtAddDate->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogInfoDevis::OnAddDate), NULL, this);
    // Reprise...
    AddParamCtrl(type_singleLine, PagePanel, PageSizer, "numDevis", _("Estimate  / invoice id :"));
    AddParamCtrl(type_multiLine, PagePanel, PageSizer, "description", _("Description :"));
    PagePanel->SetSizer(PageSizer);
    GetNotebook()->AddPage(PagePanel, _("General"));

    // Prix
    PagePanel = new wxPanel(GetNotebook(), wxID_ANY);
    PageSizer = new wxBoxSizer(wxVERTICAL);
    AddParamCtrl(type_double, PagePanel, PageSizer, "discount", _("Discount :"));
    AddParamCtrl(type_double, PagePanel, PageSizer, "discountRate", _("Discount rate (%):"));
    AddParamCtrl(type_double, PagePanel, PageSizer, "paymentOn", _("Payment on :"));
    AddParamCtrl(type_check, PagePanel, PageSizer, "isEcoPart", _("Activate Eco Part"));
    AddParamCtrl(type_double, PagePanel, PageSizer, "servicesTVA", _("Services (port charges, dump charges...) taxe (%) :"));

    AddParamCtrl(type_check_enable_next, PagePanel, PageSizer, "isDumpCharges", _("Activate dump charge"));
    AddParamCtrl(type_double, PagePanel, PageSizer, "dumpCharges", _("Dump charges :"));

    AddParamCtrl(type_check_enable_next, PagePanel, PageSizer, "isPort", _("Activate port charge"));
    AddParamCtrl(type_double, PagePanel, PageSizer, "port", _("Port charges :"));


    PagePanel->SetSizer(PageSizer);
    GetNotebook()->AddPage(PagePanel, _("Prices"));
}
//------------------------------------------------------------------------------

void DialogInfoDevis::OnAddDate(wxCommandEvent& event)
{
    wxString str;

    str = m_txtInfo->GetValue();
    str += _T("\n\n");
    str += (wxDateTime::Today()).Format(_T("%A %d %B %Y"));

    m_txtInfo->SetValue(str);
}
