///File : TextBase.hpp
//------------------------------------------------------------------------------
/*
    This file is part of DevisMaker.

    DevisMaker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DevisMaker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DevisMaker.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#ifndef MDO_TEXT_BASE_HPP_DEVIS_MAKER
#define MDO_TEXT_BASE_HPP_DEVIS_MAKER
//------------------------------------------------------------------------------
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
//------------------------------------------------------------------------------
#include "config.hpp"
#include "buildVersionOptions.hpp"
//------------------------------------------------------------------------------
#include <DevisManager.hpp>
#include "DrawableObject.hpp"
//------------------------------------------------------------------------------
#include "strWxStdConv.hpp"
//------------------------------------------------------------------------------

namespace mdo
{
	struct StructTextData
	{
	    // To save
		StructWxColorFont font;
		bool isBorder;
		int hAlign;
		int vAlign;

        // Not to save
        wxString textToDraw; // Text modifié
	};

	class TextBase : public DrawableObject
	{
	public:
        TextBase(ConfigManager *cfg, ConfigManager *devisCfg, DrawableObject *parrentSizer, const std::string &name = "");

        // Cfg
		virtual void LoadFromCfg(const std::string &name = "") = 0;
		virtual void SaveToCfg(const std::string &name = "") = 0;
		virtual void CreateToCfg(const std::string &name = "") = 0;
		virtual void RemoveFromCfg(const std::string &name = "", const bool &withChilds = true) = 0;
		virtual void EditPropertyDialog(DialogProperty *window) = 0;

		virtual bool CalculSizeReal(wxDC *dc, const int &width, const int &askedHeight = 0) = 0;

		virtual void Draw(wxDC *dc, const wxPoint &pos);

	protected:
        StructTextData m_data;
	};
}


#endif // MDO_TEXT_BASE_HPP_DEVIS_MAKER
